﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;

namespace CancellationSample
{
    class Program
    {
        static void Main(string[] args)
        {
            var cts = new CancellationTokenSource();
            CancellationToken token = cts.Token;

            Task task = Task.Factory.StartNew(() =>
            {
                Thread.Sleep(1000);
                while (true)
                {
                    if (token.IsCancellationRequested)
                    {
                        token.ThrowIfCancellationRequested();
                    }
                }
            }, cts.Token);
            cts.Cancel();
            Console.WriteLine("Abbruch der parallelen Operation ...");

            try
            {
                task.Wait();
            }
            catch (AggregateException ex)
            {
                Console.WriteLine("In catch: " + ex.InnerException.Message);
            }
            Console.ReadLine();
        }
    }
}
