﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Diagnostics;

namespace ParallelForSample
{
    class Program
    {
        static void Main(string[] args)
        {
            Stopwatch watch = new Stopwatch();
            watch.Start();
            ParallelTest();
            watch.Stop();
            Console.WriteLine("Parallel: {0}", watch.ElapsedMilliseconds);

            watch.Reset();
            watch.Start();
            SynchTest();
            watch.Stop();
            Console.WriteLine("Synchron: {0}", watch.ElapsedMilliseconds);
            Console.ReadLine();
        }

        static void SynchTest()
        {
            double[] arr = new double[10000000];
            for(int i = 0; i < 10000000; i++)
                arr[i] = Math.Pow(i, 0.333) * Math.Sqrt(Math.Sin(i));
        }

        static void ParallelTest()
        {
            double[] arr = new double[10000000];
            Parallel.For(0, 10000000, i => {
                arr[i] = Math.Pow(i, 0.333) * Math.Sqrt(Math.Sin(i));
                
            });
        }
    }
}
