﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Zahlenkonsument
{
    class Program
    {
        public static bool finished = false;
        public static bool thread1Waiting = false;
        public static bool thread2Waiting = false;
        static void Main(string[] args)
        {
            MyNumber zahl = new MyNumber();
            ProduceNumber prod = new ProduceNumber(zahl);
            ConsumeNumber cons = new ConsumeNumber(zahl);
            Thread thread1, thread2;
            // Threads instanziieren
            thread1 = new Thread(new ThreadStart(prod.MakeNumber));
            thread2 = new Thread(new ThreadStart(cons.GetNumber));
            // Threads starten
            thread1.Start();
            thread2.Start();
            Console.ReadLine();
        }
    }
    // ------ erzeugt eine Zahl ------------
    class ProduceNumber
    {
        private MyNumber obj;
        public ProduceNumber(MyNumber obj)
        {
            this.obj = obj;
        }
        public void MakeNumber()
        {
            Random rnd = new Random();
            Monitor.Enter(obj);
            for (int i = 0; i <= 10; i++)
            {
                Program.thread1Waiting = true;
                // falls der Konsumer-Thread noch nicht im Wartezustand ist,
                // selbst in den Wartezustand gehen
                if (Program.thread2Waiting == false)
                    Monitor.Wait(obj);
                obj.Number = rnd.Next(0, 1000);
                Console.WriteLine("Nummer {0} erzeugt", obj.Number);
                // dem nächsten in der Warteschlange stehenden Objekt
                // den Monitor übergeben
                Monitor.Pulse(obj);
                Program.thread2Waiting = false;
            }
            Program.finished = true;
            Monitor.Exit(obj);
        }
    }
    // --------- verbraucht eine Zahl -------------
    class ConsumeNumber
    {
        private MyNumber obj;
        public ConsumeNumber(MyNumber obj)
        {
            this.obj = obj;
        }
        public void GetNumber()
        {
            Monitor.Enter(obj);
            // wenn sich der Erzeugerthread im Wartezustand
            // befindet, ihn 'bereit' schalten
            if (Program.thread1Waiting)
                Monitor.Pulse(obj);
            Program.thread2Waiting = true;
            while (Monitor.Wait(obj))
            {
                Console.WriteLine("Nummer {0} verbraucht", obj.Number);
                Monitor.Pulse(obj);
                if (Program.finished) Thread.CurrentThread.Abort();
            }
            Monitor.Exit(obj);
        }
    }
    // ------------ repräsentiert eine Zahl -------------------
    class MyNumber
    {
        private int intValue;
        public int Number
        {
            get { return intValue; }
            set { intValue = value; }
        }
    }

}
