﻿using System;
using System.Configuration;
using System.Collections.Specialized;

namespace AppSettingsSample
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Ursprüngliche 'appSettings'-Einstellungen:");
            ShowAppSettings();
            Console.WriteLine("\nHinzufügen eines Eintrags:");
            // Bezeichner des Eintrags festlegen
            string entry = "Nummer" + ConfigurationManager.AppSettings.Count;
            // 'appSettings'-Eintrag hinzufügen
            Configuration config = ConfigurationManager.OpenExeConfiguration(ConfigurationUserLevel.None);
            config.AppSettings.Settings.Add(entry, DateTime.Now.ToLongTimeString());
            // Ändern des ersten Eintrags
            if (config.AppSettings.Settings.Count > 2)
                config.AppSettings.Settings["Nummer" + (config.AppSettings.Settings.Count - 3)].Value = "veraltet";
            // Speichern aller Änderungen
            config.Save(ConfigurationSaveMode.Modified);
            // Erneutes Auslesen der Sektion 'appSettings'
            ConfigurationManager.RefreshSection("appSettings");
            Console.WriteLine("\nGeänderte 'appSettings'-Einstellungen:");
            ShowAppSettings();
            // Anzeige des letzten Eintrags in der Konfigurationsdatei
            Console.WriteLine("\nDer letzte Eintrag ist {0}", ConfigurationManager.AppSettings[entry]);
            Console.ReadLine();
        }

        static void ShowAppSettings()
        {
            string[] names = ConfigurationManager.AppSettings.AllKeys;
            NameValueCollection appStgs = ConfigurationManager.AppSettings;
            for (int i = 0; i < appStgs.Count; i++)
            {
                Console.WriteLine("Nr.{0} - Wert: {1}", i, appStgs[i]);
            }
        }
    }
}
