﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace DataRelationNavigation
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Data Source=.\sqlexpress;Initial Catalog=Northwind;Integrated Security=SSPI";
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = con;
            cmd.CommandText = "SELECT * FROM Orders; " +
                              "SELECT * FROM [Order Details]; " +
                              "SELECT * FROM Products";
            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.TableMappings.Add("Table", "Bestellungen");
            da.TableMappings.Add("Table1", "Bestelldetails");
            da.TableMappings.Add("Table2", "Produkte");
            da.Fill(ds);
            // DataRelation zwischen 'Orders' und Order Details' erzeugen
            DataColumn colMaster = ds.Tables["Bestellungen"].Columns["OrderID"];
            DataColumn colDetail = ds.Tables["Bestelldetails"].Columns["OrderID"];
            DataRelation rel = new DataRelation("Bestellungen_Bestelldetails", colMaster, colDetail);
            ds.Relations.Add(rel);

            // DataRelation zwischen 'Order Details' und 'Products' erzeugen
            colMaster = ds.Tables["Produkte"].Columns["ProductID"];
            colDetail = ds.Tables["Bestelldetails"].Columns["ProductID"];
            rel = new DataRelation("Produkte_Bestelldetails", colMaster, colDetail);
            ds.Relations.Add(rel);

            // zu jeder Bestellung die bestellten Artikel anzeigen
            foreach (DataRow rowOrder in ds.Tables["Bestellungen"].Rows)
            {
                Console.WriteLine("Bestellnummer: {0}", rowOrder["OrderID"]);
                foreach (DataRow rowOrderDetail in rowOrder.GetChildRows(ds.Relations["Bestellungen_Bestelldetails"]))
                {
                    DataRow rowProduct;
                    rowProduct = rowOrderDetail.GetParentRow(ds.Relations["Produkte_Bestelldetails"]);
                    Console.WriteLine("Artikel: {0}", rowProduct["ProductName"]);
                }
                Console.WriteLine(new string('-', 40));
            }
            Console.ReadLine();
        }

    }
}
