﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data;

namespace SeveralObjectContexts
{
    class Program
    {

        static void Main(string[] args)
        {
            using (NorthwindEntities context1 = new NorthwindEntities())
            {
                var prod = context1.Products.First();
                prod.ProductName = "Currywurst";
                context1.Detach(prod);
                DoSomething(prod);
            }
            Console.ReadLine();
        }

        static void DoSomething(Product prod)
        {
            using (NorthwindEntities context2 = new NorthwindEntities())
            {   
                // Original-Entität aus der Datenbank abfragen
                var dbprod = context2.Products.Where(p => p.ProductID == prod.ProductID).Single();
                context2.Detach(dbprod);
                // Entität zum Objektkontext hinzufügen
                context2.Attach(prod); 
                Console.WriteLine("Zustand (vorher):  {0}", prod.EntityState);
                // Originalwerte neu festlegen
                context2.Products.ApplyCurrentValues(dbprod);
                // Ausgabe
                ObjectStateEntry ose = context2.ObjectStateManager.GetObjectStateEntry(prod);
                Console.WriteLine("Zustand (nachher):  {0}", prod.EntityState);
                Console.WriteLine("Current:  {0}", ose.CurrentValues.GetValue(1));
                Console.WriteLine("Original: {0}\n", ose.OriginalValues.GetValue(1));
            }
        }
    }
}
